#ifndef EICIEL_MAIN_CONTROLER_HPP
#define EICIEL_MAIN_CONTROLER_HPP

#include "eiciel_main_window.hpp"
#include "eiciel_add_acl_window.hpp"
#include "gestor_acl.hpp"
#include "tipus_element_acl.hpp"

class EicielWindow;

class EicielMainControler : public SigC::Object
{
	private:
		GestorACL* gestorACL;
		EicielWindow* finestra;
		bool actualitzantFinestra;
		void oberturaFitxer();
		void sortidaAplicacio();
		void afegirACL();
		void actualitzarLlistaACL();
		void actualitzaEntradaACL(TipusElement e, string nom, 
				bool lectura, bool escriptura, bool execucio);
		void generaLlistaUsuaris(vector<string>& llistat);
		void generaLlistaGrups(vector<string>& llistat);
		void eliminarACL(string nomEntrada, TipusElement e);
		void afegirEntradaACL(string& s, TipusElement e, permisos_t& p);
		void canviACLDefault();
	public:
		friend class EicielWindow; 
		EicielMainControler();
};

#endif
